package jsystem;

import javax.microedition.lcdui.*;
import kjava.util.StringTokenizer;
import java.util.Vector;


public class ScrollPane extends CustomItem {

   Vector lines = new Vector();
   int w, h;
   int lastline = 0;   // Counted from top of lines
   Font df = Font.getDefaultFont();
   int maxLines = 200;

   StringBuffer curLine = new StringBuffer();

   public ScrollPane(String label,int w, int h){
       super(label);
       this.w=w;
       this.h=h;
       lines.addElement("");
   }


   public void sizeChanged(int w, int h){
       this.w = w;
       this.h = h;
   }


   public void write(char c){
       curLine.append(c);
       if(JSystem.ls.indexOf(c) < 0 ){ // Seems to be printable
            lines.setElementAt(new String(curLine), lines.size()-1);
       }
       String s = curLine.toString();
       if(s.endsWith(JSystem.ls) || df.stringWidth(s) >= w-8){
           lines.addElement("");
		   if(lines.size()>maxLines){
		   		lines.removeElementAt(0);
		   }
           curLine.delete(0, curLine.length());
       }
       lastline = 0;
       repaint();
   }

   public void write(byte[] b, int off,int len){
       int last = off+len;
       if(last>b.length)
          last = b.length;

       while(off < last){
          char c = (char)b[off++];
          curLine.append(c);
          if(JSystem.ls.indexOf(c) < 0 ){ // Seems to be printable
             lines.setElementAt(new String(curLine), lines.size()-1);
          }
          String s = curLine.toString();
          if(s.endsWith(JSystem.ls) || df.stringWidth(s) >= w-8){
             lines.addElement("");
			 if(lines.size()>maxLines){
		   		lines.removeElementAt(0);
		   	}
             curLine.delete(0, curLine.length());
          }
       }
       lastline = 0;
       repaint();
   }                                 

   public int getMinContentHeight(){
       return 30;
   }

   public int getMinContentWidth(){
       return 100;
   }
 

   public int getPrefContentWidth(int height){
       return w;
   }

   public int getPrefContentHeight(int width){
       return h;
   }

   public void paint(Graphics g,int w,int h){
       g.setClip(0,0,w,h);
       g.setColor(0xffffff);
       g.fillRect(0,0,w,h);
       g.setColor(0x000000);
       //g.drawRect(0,0,w,h);
       for(int i=0; i<h/df.getHeight();i++){
           int li = lines.size()-lastline-h/df.getHeight()+i;
           if(li>=0)
               g.drawString((String)lines.elementAt(li),0,i*df.getHeight(),g.TOP|g.LEFT);
       }
       
   }

   public void scrollUp(){
       if(lastline<lines.size()){
           lastline++;
           repaint();
       }
 
   }

   public void scrollDown(){
       if(lastline>0){
           lastline--;
           repaint();
       } 
   }
      
       
}
