package kjava.io;

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import jsystem.*;

public class FileInputStream extends InputStream{
	private FileConnection fc=null;
    private InputStream is=null;

/*
    public FileInputStream(String fname) throws Exception{
        try{
            is = new ByteArrayInputStream( vfs.read(fname) );
            is.skip((long)vfs.HEADER);
        }catch(Exception e){
            if( !fname.startsWith("/") )
                fname = "/"+fname; 
            is = getClass().getResourceAsStream(fname);
            if(is==null){
            // Maybe gzipped ?
               fname=fname+".gz";
               is = getClass().getResourceAsStream(fname);
               if(is==null)
                  throw new IOException("File not found.");
               is = new com.tinyline.util.GZIPInputStream(is);
            }          
        }
    }
*/
 
 	public FileInputStream(String fname) throws IOException{
		if(fname.startsWith("res/")){
			is = this.getClass().getResourceAsStream(fname.substring("res".length()) );	
			if(is==null)
				throw new IOException("Resource "+fname+" does not exist.");				
		}else if(fname.startsWith("vfs/")){
			try{
				is = new ByteArrayInputStream( JSystem.vfs.read( fname.substring("vfs/".length() ) ));
            	is.skip((long)JSystem.vfs.HEADER);
			}catch(Exception e){
				throw new IOException("Could not create ByteArrayStream.");
			}
        }else{
			fc = (FileConnection)
                	Connector.open("file://localhost/" + fname);
			if (!fc.exists()) {
                throw new IOException("File does not exists");
        	}
			is = fc.openInputStream();
		}
//		if(fname.endsWith(".gz"))
//			is = new com.tinyline.util.GZIPInputStream(is);
    }

    public int read()  throws IOException{
        return is.read();
    }

    public int read(byte[] b,
                int off,
                int len)
         throws IOException{
        return is.read(b,off,len);
    }

    public int read(byte[] b)
         throws IOException{
        return is.read(b);
    }

    public void close()
           throws IOException{
		if(is!=null)
		 	is.close();
		if(fc!=null && fc.exists())
			fc.close();
    }
}
        

