package kjava.io;

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import jsystem.*;


public class FileOutputStream extends ByteArrayOutputStream{
    private String fname;
	private FileConnection fc=null;
    private OutputStream os=null;

    public FileOutputStream(String fname)throws IOException{
		super(2048);
		this.fname = fname;
		if(!fname.startsWith("vfs/")){
			fc = (FileConnection)
                	Connector.open("file://localhost/" + fname);
			if (!fc.exists()) 
				fc.create();
			os = fc.openOutputStream();
		}
    }
	
    public FileOutputStream(String fname, boolean append)throws IOException{
		super(2048);
		this.fname = fname;
		if(!fname.startsWith("vfs/")){
			fc = (FileConnection)
                	Connector.open("file://localhost/" + fname);
			if (!fc.exists()) 
				fc.create();
			os = fc.openOutputStream();
		}
    }
	
	public void write(byte[] b,
                  int off,
                  int len){
		if(os!=null)
			try{
				os.write(b,off,len);
			}catch(Exception e){
			}
		else
			super.write(b,off,len);
	}
				  
	public void write(byte[] b)throws IOException{
		if(os!=null)
				os.write(b);
		else
			super.write(b);
	}
				  
	public void write(int b){
		if(os!=null)
			try{
				os.write(b);
			}catch(Exception e){
			}
		else
			super.write(b);
	}

    public void close()throws IOException{
		if(fname.startsWith("vfs/"))
       		JSystem.vfs.write(buf, count, fname.substring("vfs/".length()));
		else{
			os.close();
			fc.close();
		}			
        super.close();
    }
}
           

