package kjava.io;

import java.io.*;
import java.util.*;

public class FileReader extends InputStream{
	InputStream is;

    public FileReader(File f) throws FileNotFoundException{
		try{
        	is = new FileInputStream(f.getAbsolutePath());
		}catch(Exception e){
			throw new FileNotFoundException("");
		}
    }
	
    public FileReader(String fname) throws FileNotFoundException{
		try{
        	is = new FileInputStream(fname);
		}catch(Exception e){
			throw new FileNotFoundException(fname);
		}

    }

    public FileReader(InputStream is) throws FileNotFoundException{
		if(is!=null)
			this.is = is;
		else
			throw new FileNotFoundException("");
	}
	
	public int read() throws IOException{
		return is.read();
	}
	
	public void close() throws IOException{
		is.close();
	}


    public int read(char cbuf[],
                 int off,
                 int len) throws IOException{
        int c=0,i=0;
		if(len>cbuf.length-off)
			len=cbuf.length-off;
        while( i<len && (c=is.read())!=-1 ){
            cbuf[i+off]=(char)c;
            i++;
        }
		if(i==0)
			return -1;
        return i;
    }

}
